config/routes.rb
Rails.application.routes.draw do
  root 'pages#home'
  get 'about', to: 'pages#about'
  get 'signup', to: 'users#new'
  get 'login', to: 'sessions#new'
  post 'login', to: 'sessions#create'
  delete 'logout', to: 'sessions#destroy'

  resources :users, except: [:new]
  resources :articles
  resources :categories, except: [:destroy]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord
  belongs_to :user
  validates :title, presence: true, length: {minimum: 4, maximum: 100}
  validates :description, presence: true, length: {minimum: 10, maximum: 300}

  has_many :article_categories
  has_many :categories, through: :article_categories
end

app/models/article_category.rb
class ArticleCategory < ApplicationRecord
  belongs_to :article
  belongs_to :category
end

app/models/category.rb
class Category < ApplicationRecord
  validates :name, presence: true, uniqueness: true, length: {minimum: 3, maximum: 25}

  has_many :article_categories
  has_many :articles, through: :article_categories
end

app/models/user.rb
class User < ApplicationRecord
  before_save {self.email = email.downcase}
  has_many :articles, dependent: :destroy
  validates :username, presence: true, uniqueness: { case_sensitive: false }, length: {minimum: 3, maximum: 25}
  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
  validates :email, presence: true, uniqueness: { case_sensitive: false }, length: {maximum: 105},
            format: {with: VALID_EMAIL_REGEX}

  has_secure_password
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  helper_method :current_user, :logged_in?

  def current_user
    @current_user ||= User.find(session[:user_id]) if session[:user_id]
  end

  def logged_in?
    !!current_user
  end

  def require_user
    if !logged_in?
      flash[:alert] = "You must logged in!!"
      redirect_to login_path
    end
  end
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_action :set_article, only: [:edit, :show, :update, :destroy]
  before_action :require_user, except: [:index, :show]
  before_action :authorize_user, only: [:edit, :update, :destroy]

  def index
    # @articles = Article.all
    @articles = Article.paginate(page: params[:page], per_page: 5)
  end

  def create
    byebug
    @article = Article.new(article_params)
    @article.user_id = current_user.id
    if @article.save
      flash[:notice] = 'Article was created successfully!'
      redirect_to article_path(@article)
    else
      render 'new' #calling new.html.erb file not action
    end
    # render plain: params[:article]
  end

  def new
    @article = Article.new
  end

  def edit
  end

  def show
    # byebug
    # p params[:id]
  end

  def update
    if @article.update(article_params)
      flash[:notice] = 'Article was updated successfully!'
      redirect_to article_path(@article)
    else
      render 'edit'
    end
  end

  def destroy
    @article.destroy
    redirect_to articles_path
  end

  private

  def set_article
    @article = Article.find(params[:id])
  end

  def article_params
    params.require(:article).permit(:title, :description, category_ids: [])
  end

  def authorize_user
    if !current_user.admin? and current_user != @article.user
      flash[:alert] = 'Unauthorised access!!'
      redirect_to article_path(@article)
    end
  end
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: [:edit, :update, :show]
  before_action :authorize_admin, except: [:show, :index]
  
  def index
    @categories = Category.paginate(page: params[:page], per_page: 5)
  end

  def new
    @category = Category.new
  end

  def edit
  end

  def update
    if @category.update(category_params)
      flash[:notice] = 'Category was updated successfully'
      redirect_to category_path(@category)
    else
      render 'edit'
    end
  end

  def create
    @category = Category.new(category_params)
    if @category.save
      flash[:notice] = "Category was created successfully"
      redirect_to category_path(@category)
    else
      render 'new'
    end
  end

  def show
    @articles = @category.articles.paginate(page: params[:page], per_page: 5)
  end

  private

  def set_category
    @category = Category.find(params[:id])
  end

  def category_params
    params.require(:category).permit(:name)
  end

  def authorize_admin
    if !(logged_in? and current_user.admin?)
      flash[:alert] = 'Un-authorize access!!'
      redirect_to categories_path
    end
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController

  def home
    redirect_to articles_path if logged_in?
  end

  def about
  end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def new
  end

  def create
    user = User.find_by(email: params[:session][:email].downcase)
    if user && user.authenticate(params[:session][:password])
      session[:user_id] = user.id
      flash[:notice] = "Logged in successfully"
      redirect_to user_path(user)
    else
      flash.now[:alert] = 'Wrong details!!'
      render 'new'
    end
  end

  def destroy
    flash[:notice] = "Logged out"
    session[:user_id] = nil
    redirect_to root_path
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:edit, :update, :show, :destroy]
  before_action :require_user, only: [:edit, :update]
  before_action :authorize_user, only: [:edit, :update, :destroy]

  def index
    @users = User.paginate(page: params[:page], per_page: 5)
  end

  def new
    @user = User.new
  end

  def edit
  end

  def show
    @articles = @user.articles.paginate(page: params[:page], per_page: 5)
  end

  def update
    if @user.update(user_params)
      flash[:notice] = "User was updated successfully !!"
      redirect_to user_path
    else
      render 'edit'
    end
  end

  def create
    @user = User.new(user_params)
    if @user.save
      session[:user_id] = @user.id
      flash[:notice] = "Welcome to Blog++ #{@user.username}!!"
      redirect_to articles_path
    else
      render 'new'
    end
  end

  def destroy
    @user.destroy
    session[:user_id] = nil if !current_user.admin?
    flash[:notice] = 'User account successfully deleted!!'
    redirect_to users_path
  end


  private

  def set_user
    @user = User.find(params[:id])
  end

  def user_params
    params.require(:user).permit(:username, :email, :password)
  end

  def authorize_user
    if current_user != @user && !current_user.admin?
      flash[:alert] = 'Unauthorised access!!'
      redirect_to user_path(@user)
    end
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/articles/_articles.html.erb
<div class="container">
  <% articles.each do |article| %>
    <div class="row justify-content-md-center">
      <div class="col-8 mt-4">
        <div class="card text-center shadow mb-5 bg-white rounded">
          <div class="card-header font-italic">
            <% if article.user %>
              By <%= link_to article.user.username, user_path(article.user) %>
            <% end %>
            <% if article.categories.any? %>
              <div class="mt-2">
                <%= render article.categories %>
              </div>
            <% end %>
          </div>
          <div class="card-body">
            <h5 class="card-title"><%= link_to article.title, article_path(article), class: 'text-success' %></h5>
            <p class="card-text"><%= truncate(article.description, length: 40) %></p>
            <%= link_to 'View', article_path(article), class: "btn btn-outline-success" %>
            <% if logged_in? && (current_user == article.user || current_user.admin?) %>
              <%= link_to 'Edit', edit_article_path(article), class: "btn btn-outline-info" %>
              <%= link_to 'Delete', article_path(article), method: :delete, class: "btn btn-outline-danger", data: {confirm: 'Are u sure ?'} %>
            <% end %>
          </div>
          <div class="card-footer text-muted">
            <small>Created <%= time_ago_in_words(article.created_at) %> ago,
            Edited <%= time_ago_in_words(article.updated_at) %> ago
            </small>
          </div>
        </div>
      </div>
    </div>
  <% end %>
</div>

app/views/articles/_form.html.erb
<div class="container">

  <div class="row justify-content-center">
    <div class="col-10">
      <%= render "shared/errors", object: @article %>

      <%= form_with(model: @article, class:"shadow p-3 m-3 bg-info rounded", local: true) do |form| %>
        <div class="form-group row">
          <%= form.label :title, class: 'col-2 col-form-label text-light' %>
          <div class="col-10">
            <%= form.text_field :title, class:"form-control shadow rounded", placeholder: 'Title' %>
          </div>
        </div>

        <div class="form-group row">
          <%= form.label :description, class: 'col-2 col-form-label text-light' %>
          <div class="col-10">
            <%= form.text_area :description, rows: 10, class:"form-control shadow rounded", placeholder: 'Description' %>
          </div>
        </div>

        <div class="form-group row">
          <%= form.label :category, class: 'col-2 col-form-label text-light' %>
          <div class="col-10">
            <%= form.collection_select(:category_ids, Category.all, :id, :name, {prompt: 'Select category for article'}, {multiple: true,
            class: "custom-select shadow rounded"})  %>
          </div>
        </div>

        <div class="form-group row justify-content-center">
          <%= form.submit class: "btn btn-outline-light btn-lg" %>
        </div>
      <% end %>
    </div>
    <%= link_to '[ Cancel and return to articles listing ]', articles_path, class: "text-info" %>
  </div>

</div>

app/views/articles/edit.html.erb
<h1 class="text-center mt-4">Edit article</h1>
<%= render 'form' %>

app/views/articles/index.html.erb
<h1 class="text-center m-4">List of Articles</h1>

<div class="flickr_pagination m-3">
  <%= will_paginate @articles, :container => false %>
</div>
<%= render 'articles', articles: @articles %>
<div class="flickr_pagination m-3">
  <%= will_paginate @articles, :container => false %>
</div>

app/views/articles/new.html.erb
<h1 class="text-center mt-4">Create a new article</h1>
<%= render 'form' %>

app/views/articles/show.html.erb
<h2 class="text-center m-4"><%= @article.title %></h2>

<div class="container">
  <div class="row justify-content-md-center">
  <div class="col-8 mt-4">
    <div class="card text-center shadow mb-5 bg-white rounded">
      <div class="card-header font-italic">
        By <%= @article.user.username if @article.user %><br>
        <% if @article.categories.any? %>
          <div class="mt-2">
            <%= render @article.categories %>
          </div>
        <% end %>
      </div>
      <div class="card-body">
        <div class="card-text"><%= simple_format(@article.description) %></div>
        <% if logged_in? && (current_user == @article.user || current_user.admin?) %>
          <%= link_to 'Edit', edit_article_path(@article), class: "btn btn-outline-info" %>
          <%= link_to 'Delete', article_path(@article), method: :delete, class: "btn btn-outline-danger", data: {confirm: 'Are u sure ?'} %>
        <% end %>
      </div>
      <div class="card-footer text-muted">
        <small>Created <%= time_ago_in_words(@article.created_at) %> ago,
        Edited <%= time_ago_in_words(@article.updated_at) %> ago
        </small>
      </div>
    </div>
  </div>
  </div>
</div>

app/views/categories/_category.html.erb
<%= link_to category.name, category_path(category), class: "badge badge-pill badge-info mr-1" %>

app/views/categories/_form.html.erb
<div class="container">

  <div class="row justify-content-center">
    <div class="col-10">
      <%= render "shared/errors", object: @category %>

      <%= form_with(model: @category, class:"shadow p-3 m-3 bg-info rounded", local: true) do |form| %>
        <div class="form-group row">
          <%= form.label :name, "Category Name", class: 'col-2 col-form-label text-light' %>
          <div class="col-10">
            <%= form.text_field :name, class:"form-control shadow rounded", placeholder: 'Category Name' %>
          </div>
        </div>

        <div class="form-group row justify-content-center">
          <%= form.submit class: "btn btn-outline-light btn-lg" %>
        </div>
      <% end %>
    </div>
    <%= link_to '[ Cancel and return to category listing ]', categories_path, class: "text-info" %>
  </div>

</div>

app/views/categories/edit.html.erb
<h1 class="text-center mt-4">Edit category</h1>
<%= render 'form' %>

app/views/categories/index.html.erb
<h1 class="text-center m-4">Categories</h1>

<div class="flickr_pagination m-3">
  <%= will_paginate @categories, :container => false %>
</div>

<div class="container">
  <% @categories.each do |category| %>
    <div class="row justify-content-md-center">
      <div class="col-4 mt-4">
        <div class="card text-center shadow mb-5 bg-white rounded">
          <div class="card-body">
            <h5 class="card-title"><%= link_to category.name, category_path(category), class: 'text-success' %></h5>
            <p class="card-text">Articles - <%= category.articles.count %></p>
          </div>
          <div class="card-footer text-muted">
            <small>Created <%= time_ago_in_words(category.created_at) %> ago,
            Edited <%= time_ago_in_words(category.updated_at) %> ago
            </small>
          </div>
        </div>
      </div>
    </div>
  <% end %>
</div>


<div class="flickr_pagination m-3">
  <%= will_paginate @categories, :container => false %>
</div>

app/views/categories/new.html.erb
<h1 class="text-center mt-4">Create a new category</h1>
<%= render 'form' %>

app/views/categories/show.html.erb
<h1 class="text-center mt-4"><%= @category.name %></h1>

<% if logged_in? && current_user.admin? %>
  <div class="text-center mt-4">
    <%= link_to 'Edit category', edit_category_path(@category), class: "btn btn-outline-info" %>
  </div>
<% end %>

<h3 class="text-center m-4">Articles</h3>
<div class="flickr_pagination m-3">
  <%= will_paginate @articles, :container => false %>
</div>
<%= render 'articles/articles', articles: @articles %>
<div class="flickr_pagination m-3">
  <%= will_paginate @articles, :container => false %>
</div>

app/views/layouts/_flash_messages.html.erb
<div class="container">
  <% flash.each do |name, message| %>
    <% klass = "alert-success" %>
    <% klass = "alert-danger" if name == 'alert' %>
    <div class="alert <%= klass %> alert-dismissible fade show" role="alert">
      <%= message %>
      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
  <% end %>
</div>

app/views/layouts/_footer.html.erb
<footer id="sticky-footer" class="py-4 bg-dark text-white">
  <div class="container text-center">
    <small>Copyright &copy;
      <%= link_to 'Suraj Saste', 'https://www.google.co.in', class: "text-white" %>
    </small>
  </div>
</footer>

app/views/layouts/_navigation.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <%= link_to 'Blog++', root_path, class: "navbar-brand", id: "logo" %>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active d-none">
        <%= link_to 'Articles', articles_path, class: "nav-link" %>
      </li>
      <li class="nav-item">
        <%= link_to 'Users', users_path, class: "nav-link" %>
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Articles
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <% if logged_in? %>
            <%= link_to 'Create new article', new_article_path, class: "dropdown-item" %>
          <% end %>
          <%= link_to 'List of Articles', articles_path, class: "dropdown-item" %>
        </div>
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Categories
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <% if logged_in? and current_user.admin? %>
            <%= link_to 'Create new category', new_category_path, class: "dropdown-item" %>
          <% end %>
          <%= link_to 'List of Categories', categories_path, class: "dropdown-item" %>
        </div>
      </li>

      <% if logged_in? %>

        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            <%= "(Admin)" if current_user.admin? %> <%= current_user.username %>
          </a>
          <div class="dropdown-menu" aria-labelledby="navbarDropdown">
            <%= link_to 'View profile', user_path(current_user), class: "dropdown-item" %>
            <%= link_to 'Edit profile', edit_user_path(current_user), class: "dropdown-item" %>
            <%= link_to 'Delete profile', user_path(current_user), method: :delete, class: "dropdown-item text-danger", data: {confirm: 'Are you sure?'} %>
          </div>
        </li>
        <li class="nav-item">
          <%= link_to 'Log out', logout_path, class: "nav-link", method: :delete %>
        </li>
      <% else %>
        <li class="nav-item">
          <%= link_to 'Log in', login_path, class: "nav-link" %>
        </li>
        <li class="nav-item">
          <%= link_to 'Sign up', signup_path, class: "nav-link" %>
        </li>
      <% end %>
    </ul>
    <form class="form-inline my-2 my-lg-0">
      <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
    </form>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blog++</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body class="d-flex flex-column">
    <%= render 'layouts/navigation' %>
    <div id="page-content">
      <%= render 'layouts/flash_messages' %>
      <%= yield %>
    </div>
    <%= render 'layouts/footer' %>
  </body>
</html>

app/views/pages/about.html.erb
<h1>This is About page</h1>

app/views/pages/home.html.erb
<div class="container" id="home-container">
  <div class="jumbotron text-center text-white">
    <h1 class="display-4">Blog++</h1>
    <p class="lead">This is a simple hero unit, a simple jumbotron-style component for calling extra attention to featured content or information.</p>
    <hr class="my-4">
    <p>It uses utility classes for typography and spacing to space content out within the larger container.</p>
    <%= link_to "Sign Up", signup_path, class: "btn btn-success btn-lg" %>
  </div>
</div>

app/views/shared/_errors.html.erb
<% if object.errors.any? %>

  <div class="alert alert-danger alert-dismissible fade show" role="alert">
    <h4 class="alert-heading">Errors in <%= object.class.name.downcase %>!</h4>
    <ul>
      <% object.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
<% end %>

app/views/users/_form.html.erb
<div class="container">

  <div class="row justify-content-center">
    <div class="col-10">
      <%= render "shared/errors", object: @user %>

      <%= form_with(model: @user, class:"shadow p-3 m-3 bg-info rounded", local: true) do |form| %>
        <div class="form-group row">
          <%= form.label :username, class: 'col-2 col-form-label text-light' %>
          <div class="col-10">
            <%= form.text_field :username, class:"form-control shadow rounded", placeholder: 'Username' %>
          </div>
        </div>

        <div class="form-group row">
          <%= form.label :email, class: 'col-2 col-form-label text-light' %>
          <div class="col-10">
            <%= form.email_field :email, class:"form-control shadow rounded", placeholder: 'Email' %>
          </div>
        </div>

        <div class="form-group row">
          <%= form.label :password, class: 'col-2 col-form-label text-light' %>
          <div class="col-10">
            <%= form.password_field :password, class:"form-control shadow rounded", placeholder: 'Password' %>
          </div>
        </div>

        <div class="form-group row justify-content-center">
          <%= form.submit(@user.new_record? ? "Sign Up" : "Update", class: "btn btn-outline-light btn-lg") %>
        </div>
      <% end %>
    </div>
    <%= link_to '[ Cancel and return to articles listing ]', articles_path, class: "text-info" %>
  </div>

</div>

app/views/users/edit.html.erb
<h1 class="text-center mt-4">Update user</h1>
<%= render 'form' %>

app/views/users/index.html.erb
<h1 class="text-center mt-4">List of Blog++ users</h1>

<div class="flickr_pagination m-3">
  <%= will_paginate @users, :container => false %>
</div>
<div class="container">
  <% @users.each do |user| %>
    <div class="row justify-content-md-center">
      <div class="col-8 mt-4">
        <div class="card text-center shadow mb-5 bg-white rounded">
          <div class="card-header font-italic">
            <%= link_to user.username, user_path(user) %>
          </div>
          <div class="card-body">
            <%= link_to image_tag("https://cdn.pixabay.com/photo/2015/04/23/22/00/tree-736885__480.jpg", style: "height: 250px; width: 250px;", class: "rounded shadow mx-auto d-block m-3"), user_path(user) %>
            <p class="card-text">Articles - <%= user.articles.count %></p>
            <%= link_to 'View profile', user_path(user), class: "btn btn-outline-success" %>
            <% if logged_in? %>
              <% if user == current_user %>
                <%= link_to 'Edit profile', edit_user_path(user), class: "btn btn-outline-info" %>
              <% end %>
              <% if current_user.admin? %>
                <%= link_to 'Delete profile', user_path(user), class: "btn btn-outline-danger", method: :delete, data: {confirm: "Are you sure?"} %>
              <% end %>
            <% end %>
          </div>
          <div class="card-footer text-muted">
            <small>Joined <%= time_ago_in_words(user.created_at) %> ago</small>
          </div>
        </div>
      </div>
    </div>
  <% end %>
</div>
<div class="flickr_pagination m-3">
  <%= will_paginate @users, :container => false %>
</div>

app/views/users/new.html.erb
<h1 class="text-center mt-4">Sign Up</h1>
<%= render 'form' %>

app/views/users/show.html.erb
<h1 class="text-center mt-4"><%= @user.username %>'s profile</h1>

<%= image_tag "https://cdn.pixabay.com/photo/2015/04/23/22/00/tree-736885__480.jpg", style: "height: 250px; width: 250px;", class: "rounded shadow mx-auto d-block m-5" %>

<% if logged_in? && @user == current_user %>
  <div class="text-center mt-4">
    <%= link_to 'Edit profile', edit_user_path(@user), class: "btn btn-outline-info" %>
  </div>
<% end %>

<h3 class="text-center m-4">Articles</h3>
<div class="flickr_pagination m-3">
  <%= will_paginate @articles, :container => false %>
</div>
<%= render 'articles/articles', articles: @articles %>
<div class="flickr_pagination m-3">
  <%= will_paginate @articles, :container => false %>
</div>